package treeBetterTest;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.io.File;
import java.text.DateFormat;
import java.text.DateFormatSymbols;
import java.util.Date;
import java.util.Hashtable;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;

public class OsnovniFrejm extends JFrame {

    JTree drvoFS;
    JScrollPane skrol;
    public OsnovniFrejm() {

	setPreferredSize(new Dimension(500, 500));
	setVisible(true);
	setDefaultCloseOperation(EXIT_ON_CLOSE);
	setLayout(new BorderLayout());
	dodajKomponente();
	pack();
    }

    public void dodajKomponente() {
	
	FSTreeNode root = new FSTreeNode(new File("C:/"));
	//inicijalno ucitavamo samo prvi nivo fajl sistema,
	//a maxDubina nam je ogranicenje do kojeg inicijalno ucitavamo
	FSTreeModel model = new FSTreeModel(root,1);
	drvoFS = new JTree(model);
	//nakon toga cekamo akciju korisnika, i hvatamo momenat
	//kada se klikne na plusic za rasirenje drveta
	drvoFS.addTreeExpansionListener(new TreeExpansionListener(){
	   @Override
	    public void treeCollapsed(TreeExpansionEvent event) {
	        // TODO Auto-generated method stub
	        
	    }
	   @Override
	public void treeExpanded(TreeExpansionEvent event) {
	       
	       JTree drvo=(JTree)event.getSource();
	       //uzimamo mesto gde je kliknut + na drvetu
	       FSTreeNode kliknut=(FSTreeNode) event.getPath().getLastPathComponent();
	       //uzimamo model
	       FSTreeModel model=(FSTreeModel)drvo.getModel();
	       //sirimo samo taj deo drveta, konsultovanjem modela naravno
	       model.ucitajPojedinacni(kliknut);
	       
	}
	});
	skrol=new JScrollPane();
	skrol.setViewportView(drvoFS);
	getContentPane().add(skrol, BorderLayout.CENTER);
    }

    /**
     * @param args
     */
    public static void main(String[] args) {
	// TODO Auto-generated method stub
	OsnovniFrejm of = new OsnovniFrejm();

    }

}

class FSTreeModel extends DefaultTreeModel {
    FSTreeNode root;
    int maxDubina;

    public FSTreeModel(TreeNode root) {
	super(root);
    }

    public FSTreeModel(FSTreeNode root, int maxDubina) {
	super(root);
	this.root = root;
	this.maxDubina=maxDubina;
	//ucitavamo samo jedan nulti nivo
	ucitaj(root,0);
    }

    private void ucitaj(FSTreeNode cvor, int dubina) {

	if(dubina==maxDubina)
	    return;
	File f = new File(cvor.putanja);
	File[] fajlovi = f.listFiles();
	if (fajlovi != null) {
	    for (int i = 0; i < fajlovi.length; i++) {
		FSTreeNode fsnode = new FSTreeNode(fajlovi[i]);
		if(fajlovi[i].isDirectory())
		    fsnode.add(new DefaultMutableTreeNode());
		cvor.add(fsnode);
		ucitaj(fsnode,dubina+1);
	    }
	}
    }
    
    public void ucitajPojedinacni(FSTreeNode cvor){
	
	//ucitavamo pojedinacni cvor, dakle listamo samo 
	//direktorijum na kliknutoj lokaciji
	File f = new File(cvor.putanja);
	File[] fajlovi = f.listFiles();
	cvor.removeAllChildren();
	if (fajlovi != null) {
	    Object[] novi=new Object[fajlovi.length]; 
			int[] indeksi=new int[fajlovi.length];
	    for (int i = 0; i < fajlovi.length; i++) {
		FSTreeNode fsnode = new FSTreeNode(fajlovi[i]);
		indeksi[i]=i;
		novi[i]=fsnode;
		if(fajlovi[i].isDirectory())
		    fsnode.add(new FSTreeNode(f));
		cvor.add(fsnode);
	    }
	    //obavestavamo graficku komponentu o dodatim elementima u modelu
	    fireTreeNodesInserted(this, cvor.getPath(), indeksi, novi);
	}
    }

}

class FSTreeNode extends DefaultMutableTreeNode {

    String naziv;

    String putanja;

    boolean jeDirektorijum;

    Date poslednjaIzmena;

    public FSTreeNode(File f) {
	super();
	naziv = f.getName();
	putanja = f.getPath();
	jeDirektorijum = f.isDirectory();
	poslednjaIzmena = new Date(f.lastModified());
    }

    @Override
    public String toString() {
	return naziv;
    }
    
    
}
