package treeTest;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.io.File;
import java.text.DateFormat;
import java.util.Date;
import java.util.Hashtable;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;

public class OsnovniFrejm extends JFrame {

    JTree drvoFS;
    JScrollPane skrol;
    public OsnovniFrejm() {

	setPreferredSize(new Dimension(500, 500));
	setVisible(true);
	setDefaultCloseOperation(EXIT_ON_CLOSE);
	setLayout(new BorderLayout());
	dodajKomponente();
	pack();
    }

    public void dodajKomponente() {
	//kreiramo koreni cvor sa pocetkom na c particiji
	FSTreeNode root = new FSTreeNode(new File("C:/"));
	//definisemo model za ovaj cvor, tako da ide do  najvise
	//dubine 3
	FSTreeModel model = new FSTreeModel(root,3);
	//prosledjujemo drvetu model
	drvoFS = new JTree(model);
	//postavljamo prozor sa skrolom
	skrol=new JScrollPane();
	//postavljamo da se drvo vidi kroz taj prozor
	skrol.setViewportView(drvoFS);
	getContentPane().add(skrol, BorderLayout.CENTER);
    }

    /**
     * @param args
     */
    public static void main(String[] args) {
	// TODO Auto-generated method stub
	OsnovniFrejm of = new OsnovniFrejm();

    }

}

/*osnovni podrazumevani model za drvo je DefaultTreeModel
 * nama je potreban model specijalizovan za prikaz fajl sistema
 *  sa jos nekim informacijama, kao sto je koreni direktorijum
 *  i maksimalna dubina do koje ucitavamo
 * 
 */
class FSTreeModel extends DefaultTreeModel {
    FSTreeNode root;
    int maxDubina;

    public FSTreeModel(TreeNode root) {
	super(root);
    }

    public FSTreeModel(FSTreeNode root, int maxDubina) {
	super(root);
	this.root = root;
	this.maxDubina=maxDubina;
	//OVO JE POGRESNO ZAMISLJENO!
	//Naime, ovo ucitavanje je vrlo skupo, posebno
	//ako je maxDubina velika, nije realno ocekivati
	//da ce se ceo fajl sistem pri startu aplikacije
	//ucitati, a i nepotrebno je..
	ucitaj(root,0);
    }

    private void ucitaj(FSTreeNode cvor, int dubina) {

	if(dubina==maxDubina)
	    return;
	//rekurzivna funkcija za ucitavanje FS
	File f = new File(cvor.putanja);
	File[] fajlovi = f.listFiles();
	if (fajlovi != null) {
	    for (int i = 0; i < fajlovi.length; i++) {
		FSTreeNode fsnode = new FSTreeNode(fajlovi[i]);
		cvor.add(fsnode);
		ucitaj(fsnode,dubina+1);
	    }
	}
    }

}

/*potrebno nam je i specificna struktura za informacije
 * o cvoru drveta. Podrazumevani cvor koji koristi 
 * DefaultTreeModel je DefaultMutableTreeNode, nama je opet
 * potrebna struktura sa dodatnim informacijama o svakom fajlu
 * kao sto su naziv, putanja...
 */
class FSTreeNode extends DefaultMutableTreeNode {

    String naziv;

    String putanja;

    boolean jeDirektorijum;

    Date poslednjaIzmena;

    public FSTreeNode(File f) {
	super();
	naziv = f.getName();
	putanja = f.getPath();
	jeDirektorijum = f.isDirectory();
	poslednjaIzmena = new Date(f.lastModified());
    }

    @Override
    public String toString() {
	return naziv;
    }
}
